// ==UserScript==
// @name        Whisky.de-Forum ++
// @author      WithKeys
// @namespace   tuxproject.de
// @description Zusätzliche Funktionen für das Whisky.de-Forum.
// @include     /(www.?)whisky.de\/forum\/.*/
// @include     /(www.?)whisky.de\/tfg\/forum.html$/
// @exclude     /\.(jpe?g|png|gif)$/
// @require     https://raw.githubusercontent.com/franciscop/umbrella/master/umbrella.min.js
// @version     2.3
// @downloadURL https://gist.github.com/dertuxmalwieder/5ad281037ed627de23f88f79629913cb/raw/WDE++.user.js
// @grant       GM_addStyle
// @grant       GM_getValue
// @grant       GM_setValue
// ==/UserScript==


u("#navigation .navigation-realms ul").append('<li><a href="#" id="wdeplus_btn">WDE++</a></li>');

// -------- Einstellungsdialog:

u("body").append ('                                      \
    <div id="wdeplusSettingsCtr">                        \
    <form>                                               \
        <div class="wdeplusHdr">WDE++: Einstellungen fürs Whiskyforum</div> \
\
        <input type="checkbox" name="wdeChkConvertWID" id="wdeChkConvertWID" /> \
        <label for="wdeChkConvertWID" title="Wandelt &quot;WID: ...&quot; automatisch in Links zum Whisky um.">WIDs als Links darstellen</label> \
\
        <br />                                           \
\
        <div style="margin-left:16px">                   \
            Anzeigestil:                                 \
\
            <input type="radio" name="wdeRdConvertWIDStyle" value="1" id="wdeRdConvertWIDStyle1" /> \
            <label for="wdeRdConvertWIDStyle1" title="Zeigt [WB] an.">[WB]</label> \
\
            <input type="radio" name="wdeRdConvertWIDStyle" value="2" id="wdeRdConvertWIDStyle2" /> \
            <label for="wdeRdConvertWIDStyle2" title="Zeigt [Whisky-ID] an.">[123456]</label> \
\
            <input type="radio" name="wdeRdConvertWIDStyle" value="3" id="wdeRdConvertWIDStyle3" /> \
            <label for="wdeRdConvertWIDStyle3" title="Zeigt [WB: Whisky-ID] an.">[WB: 123456]</label> \
        </div>                                           \
\
        <br />                                           \
\
        <input type="checkbox" name="wdeChkUncropQuotes" id="wdeChkUncropQuotes" /> \
        <label for="wdeChkUncropQuotes" title="Entfernt verschachtelte Zitate und klappt Zitate immer aus.">Zitate kompakter anzeigen</label> \
\
        <br />                                           \
\
        <input type="checkbox" name="wdeChkPinHeader" id="wdeChkPinHeader" /> \
        <label for="wdeChkPinHeader" title="Hält den Kopfbereich immer im sichtbaren Bereich.">Kopfbereich anheften</label> \
\
        <br />                                           \
\
        <input type="checkbox" name="wdeChkLeftSidebar" id="wdeChkLeftSidebar" /> \
        <label for="wdeChkLeftSidebar" title="Hinweis: Alle Elemente in der linken Leiste werden gelöscht!">Linke Seitenleiste ausblenden</label> \
\
        <br />                                           \
\
        <input type="checkbox" name="wdeChkRightSidebar" id="wdeChkRightSidebar" /> \
        <label for="wdeChkRightSidebar" title="Hinweis: Die Suchleiste wird in die linke Seitenleiste verschoben.">Rechte Seitenleiste ausblenden</label> \
\
        <br /><br />                                     \
\
        <input type="text" name="wdeThreadIgnoreList" id="wdeThreadIgnoreList" placeholder="Die hier eingetragenen Themen werden ausgeblendet." /> \
        <label for="wdeThreadIgnoreList" title="Die hier eingetragenen Themen werden ausgeblendet.">Zu ignorierende Themen (IDs oder Titel, mit Semikolon getrennt)<br /><span class="wdeplusHint"><b>Achtung:</b> Unter "Neueste Beiträge" funktionieren nur die Titel!</span></label> \
\
        <br /><br />                                     \
\
        <input type="text" name="wdeUserIgnoreList" id="wdeUserIgnoreList" placeholder="Die hier eingetragenen Benutzer werden ausgeblendet." /> \
        <label for="wdeUserIgnoreList" title="Die hier eingetragenen Benutzer werden ausgeblendet.">Zu ignorierende Benutzer (mit Semikolon getrennt)</label> \
\
        <br /><br />                                     \
\
        <button id="wdeSaveBtn" type="button">speichern und neu laden</button>  \
        <button id="wdeCloseBtn" type="button">abbrechen und schließen</button> \
    </form>                                              \
    </div>                                               \
');


// -------- Variablen (werden in den Einstellungen gesetzt):

let ConvertWIDs         = GM_getValue('convertWIDs', 0);
let ConvertWIDStyle     = GM_getValue('convertWIDStyle', 3);
let PinHeader           = GM_getValue('pinHeader', 0);
let DisableLeftSidebar  = GM_getValue('disableLeftSidebar', 0);
let DisableRightSidebar = GM_getValue('disableRightSidebar', 1);
let UncropQuotes        = GM_getValue('uncropQuotes', 1);
let UserIgnoreList      = GM_getValue('userIgnoreList', '');
let ThreadIgnoreList    = GM_getValue('threadIgnoreList', '');

// Dialogelemente vorbelegen:

if (ConvertWIDs == 1)         { u("#wdeChkConvertWID").attr("checked", true); }
u("#wdeRdConvertWIDStyle" + ConvertWIDStyle).attr("checked", true);
if (PinHeader == 1)           { u("#wdeChkPinHeader").attr("checked", true); }
if (DisableLeftSidebar == 1)  { u("#wdeChkLeftSidebar").attr("checked", true); }
if (DisableRightSidebar == 1) { u("#wdeChkRightSidebar").attr("checked", true); }
if (UncropQuotes == 1)        { u("#wdeChkUncropQuotes").attr("checked", true); }
document.getElementById("wdeUserIgnoreList").value = UserIgnoreList;
document.getElementById("wdeThreadIgnoreList").value = ThreadIgnoreList;



// -------- Trigger für das Einstellungsmenü:

function cbToBit(node) {
    // Checkboxselector rein, 1 oder 0 raus.
    return u(node).is(":checked") ? 1 : 0;
}

document.getElementById("wdeplus_btn").addEventListener("click", function() {
    u("#wdeplusSettingsCtr").addClass("visible");
}, false);

u("#wdeCloseBtn").on("click", function () {
    u("#wdeplusSettingsCtr").removeClass("visible");
});

u("#wdeSaveBtn").on("click", function () {
    // Speichern:
    GM_setValue("convertWIDs", cbToBit("#wdeChkConvertWID"));
    GM_setValue("pinHeader", cbToBit("#wdeChkPinHeader"));
    GM_setValue("disableLeftSidebar", cbToBit("#wdeChkLeftSidebar"));
    GM_setValue("disableRightSidebar", cbToBit("#wdeChkRightSidebar"));
    GM_setValue("uncropQuotes", cbToBit("#wdeChkUncropQuotes"));
    GM_setValue("userIgnoreList", document.getElementById("wdeUserIgnoreList").value);
    GM_setValue("threadIgnoreList", document.getElementById("wdeThreadIgnoreList").value);

    if (cbToBit("#wdeRdConvertWIDStyle1"))      GM_setValue("convertWIDStyle", 1);
    else if (cbToBit("#wdeRdConvertWIDStyle2")) GM_setValue("convertWIDStyle", 2);
    else                                        GM_setValue("convertWIDStyle", 3);

    window.location.reload(true);
});


// -------- Tu' Dinge auf der Seite:

const wdeObserver = new MutationObserver(function(mutations) {
    // Wegen des blöden :-) AJAX-Krempels müssen wir aktiv gucken,
    // ob sich die Seite ändert, und ggf. reagieren.
    mutations.forEach(function(mutation) {
        if (mutation.type == "childList" && mutation.addedNodes != null) {
            // Beiträge wurden nachgeladen:
            processPage();
        }
    });
});
const obsConfig = {
    attributes: true,
    childList: true,
    characterData: true,
    subtree: true
};
wdeObserver.observe(document.getElementById("content"), obsConfig);

function processPage() {
    // Selektor für ganze Seite:
    const pagewrapper = u(".page-content");

    // Selektor für Themenliste (Forum):
    const threadListNormal = u("ul.DataList.Discussions div li.ItemDiscussion");

    // Selektor für Themenliste (Neueste Beiträge):
    const threadListRecent = u("div.vanilla-latest-comments ul.DataList.MessageList li.Item");

    // Selektor für Beitragsinhalte:
    const allPostTexts = u(".MessageList .Item .clearfix .right-block .Item-BodyWrap .Item-Body");

    allPostTexts.each(function(node, i) {
        if (u(node).hasClass("wdeplusprocd")) {
            // Bereits verarbeitet.
            return;
        }

        const beitragsDiv = u(node).parent().parent().parent();

        // Beiträge ignorierter Benutzer ausblenden:
        const ignoreUserListArray = UserIgnoreList.split(";");
        if (ignoreUserListArray.length > 0) {
            const postUser = u(beitragsDiv).find("a.Username").html();
            if (ignoreUserListArray.includes(postUser)) {
                // Dieser Beitrag kann weg.
                u(beitragsDiv).replace("<div>Ignorierter Beitrag von " + postUser + ".</div>");
            }
        }

        // WIDs konvertieren:
        if (ConvertWIDs) {
            // Alle Links zu WIDs, die die Forensoftware bereits eingebaut hat, wieder entfernen:
            const allLinksInNode = u(node).find("a");
            allLinksInNode.each(function(anchor, i) {
                const href = u(anchor).attr("href");
                const innerText = u(anchor).html();

                if (href != null && href.match(/:WID:/) != null) {
                    u(anchor).replace(innerText);
                }
            });

            const origHtml = u(node).html();

            // Hinweis: Firefox kann kein negatives Lookbehind und wird sich beklagen, wenn man es versucht.
            // Wir müssen hier daher die einfachere Variante nehmen. Da die Forensoftware manchmal &nbsp;
            // und/oder irgendwelche HTML-Tags einfügt, müssen wir das natürlich auch entfernen.
            const regex = /WID([:\s]|(&nbsp;|<.*?>))+(\d+)/g;

            let ersetzen = '';
            switch (ConvertWIDStyle) {
                case 1:
                    // Nur "[WB]":
                    ersetzen = "[WB]";
                    break;
                case 2:
                    // Nur "[(WID)]":
                    ersetzen = "[$3]";
                    break;
                case 3:
                    // "[WB: (WID)]":
                    ersetzen = "[WB: $3]";
                    break;
            }

            const newHtml = origHtml.replace(regex, '<a href="https://www.whiskybase.com/whiskies/whisky/$3" target="_blank" title="Whisky $3 in der Base">' + ersetzen + '</a>');

            u(node).html(newHtml);
        }

        u(node).addClass("wdeplusprocd");
    });

    // Ignorierte Themen ausblenden:
    const ignoreThreadListArray = ThreadIgnoreList.split(";");
    if (ignoreThreadListArray.length > 0) {
        if (threadListNormal != null) {
            // Themenliste. Hier können IDs und Titel entfernt werden.
            threadListNormal.each(function(node, i) {
                // Nummerische IDs:
                const discussionId = u(node).attr("id");
                const numericalId = discussionId.replace("Discussion_", "");
                if (ignoreThreadListArray.includes(numericalId)) {
                    // Gefunden. Ganzen Eintrag entfernen.
                    u(node).remove();
                    return;
                }

                // Titel:
                const titel = u(node).find("div.Title a").html();
                if (ignoreThreadListArray.includes(titel)) {
                    // Gefunden. Ganzen Eintrag entfernen.
                    u(node).remove();
                    return;
                }
            });
        }

        if (threadListRecent != null) {
            // Beitragsliste. Hier funktionieren nur Titel.
            threadListRecent.each(function(node, i) {
                const titel = u(node).find(".MItem b a").html();
                if (ignoreThreadListArray.includes(titel)) {
                    // Gefunden. Ganzen Eintrag entfernen.
                    u(node).remove();
                    return;
                }
            });
        }
    }

    if (UncropQuotes == 1) {
        // "cropped" aus Zitaten entfernen (nervt nur unnötig):
        u("blockquote").removeClass("cropped");

        // Zitate in Zitaten entfernen (braucht keiner):
        u("blockquote div blockquote").remove();
    }
    else {
        // Bugfix: Dieses Script macht Ausklappen von Zitaten kaputt.
        u("blockquote").on("click", function(e) {
            e.preventDefault();
            u(this).removeClass("cropped");
        });
    }

    if (!u(pagewrapper).hasClass("wdeplusprocd")) {
        // Die Seite wurde noch nicht angepasst.
        if (PinHeader == 1) {
            // Kopfzeile anheften:
            u("#Body").attr("style", "margin-top: 170px");
            u(".container-fluid").attr("style", "position: fixed; z-index: 999999; background-color: antiquewhite;");
        }

        // Seitenleiste(n) ausblenden:
        let breiteLinks  = u("#sidebar-left").size().width;
        let breiteRechts = u("#sidebar-right").size().width;
        let breiteMitte  = u(pagewrapper).size().width;

        if (DisableLeftSidebar == 1 && u("#sidebar-left") != null) {
            u("#sidebar-left").remove();
            breiteMitte += breiteLinks;
        }

        if (DisableRightSidebar == 1 && u("#sidebar-right") != null) {
            // Die Suchbox in die linke Sidebar schieben, falls diese noch
            // da ist...
            if (u("#sidebar-left") != null) {
                let globalSearchbox = u("#sidebar-right .whisky-searchBox").clone();
                let origSearchPanel = u("#sidebar-left .top-pannel .row div").first();
                u(origSearchPanel).append(globalSearchbox);

                // Der Button ist inkonsistent. Eingabetaste drücken muss reichen.
                u("#Form_Go").remove();
            }

            u("#sidebar-right").remove();
            breiteMitte += breiteRechts;
        }

        // Breite anpassen, falls Seitenleiste(n) ausgeblendet:
        if (DisableRightSidebar == 1 || DisableLeftSidebar == 1) {
            u(pagewrapper).attr("style", "width:" + breiteMitte + "px");

            // Auch das "antworten"-Element darf breiter sein:
            const antwortenForm = u(".MessageForm.fixed").first();
            let antwortenStyle = "";
            if (antwortenForm != null) {
                if (DisableLeftSidebar == 0) {
                    antwortenStyle += "left:" + breiteLinks + "px;";
                }
                antwortenStyle += "max-width:" + breiteMitte + "px;";
                antwortenStyle += "width:" + breiteMitte + "px;";

                u(antwortenForm).attr("style", antwortenStyle);
            }
        }

        // Als "verarbeitet" kennzeichnen:
        u(pagewrapper).addClass("wdeplusprocd");
    }
}

// Falls "Infinite Scroll" deaktiviert ist, greift der MutationObserver nicht.
// Initial muss processPage() daher wenigstens einmal aufgerufen werden.
processPage();


// -------- Beim Größenändern des Fensters Elemente anpassen:

function wdeResize() {
    const pagewrapper = u(".page-content");

    const breiteLinks   = DisableLeftSidebar == 1 ? 0 : u("#sidebar-left").size().width;
    const breiteRechts  = DisableRightSidebar == 1 ? 0 : u("#sidebar-right").size().width;
    const breiteMitte   = "calc(100% - " + breiteLinks + "px - " + breiteRechts + "px)";

    // Auch das "antworten"-Element darf breiter sein:
    const antwortenForm = u(".MessageForm.fixed").first();
    let antwortenStyle = "";
    if (antwortenForm != null) {
        if (DisableLeftSidebar == 0) {
            antwortenStyle += "left:" + breiteLinks + ";";
        }
        antwortenStyle += "max-width:" + breiteMitte + ";";
        antwortenStyle += "width:" + breiteMitte + ";";

        u(antwortenForm).attr("style", antwortenStyle);
    }

    u(pagewrapper).attr("style", "width:" + breiteMitte);
}

if (DisableRightSidebar == 1 || DisableLeftSidebar == 1) {
    // Eine Größenänderung ist nur bei Seitenleistenausblendung sinnvoll.
    window.addEventListener("resize", wdeResize);
}


// -------- CSS:

GM_addStyle("                               \
    #wdeplusSettingsCtr {                   \
        position:               fixed;      \
        padding:                2em;        \
        background:             #FFF2E1;    \
        border:                 3px double black; \
        border-radius:          1ex;        \
        z-index:                999;        \
        width:                  614px;      \
        height:                 524px;      \
    }                                       \
\
    #wdeplusSettingsCtr:not(.visible) {     \
        /* Der Dialog ist immer da, nur     \
        manchmal versteckt. */              \
        display: none;                      \
    }                                       \
\
    #wdeplusSettingsCtr form label {        \
        font-weight: normal;                \
        padding-top: 4px;                   \
    } \
\
    #wdeplusSettingsCtr form button {       \
        border: 1px solid black;            \
    } \
\
    #wdeSaveBtn {                           \
        background-color: lightgreen;       \
    }                                       \
\
    #wdeCloseBtn {                          \
        background-color: #fcaca4;          \
    }                                       \
\
    .wdeplusHdr {                           \
        font-size: 18px;                    \
        font-weight: bold;                  \
        margin-bottom: 18px;                \
    }                                       \
\
    .wdeplusHint {                          \
        font-size: 12px;                    \
        margin-top: 20px;                   \
    }                                       \
\
    .FormWrapper-Condensed {                \
        /* Bonus: Antworten-Formular mit    \
           sichtbarem Rand. Sieht sonst     \
           scheiße aus. */                  \
        border: 1px solid #CF4D3B;          \
    }                                       \
\
    @media only screen and (max-width: 650px) { \
        .wdeplusHdr {                       \
            /* Bildschirm klein? Überschrift weg. */ \
            display: none;                  \
        }                                   \
    }                                       \
\
    @media only screen and (min-width: 650px) { \
        #wdeplusSettingsCtr {               \
            /* Zentrieren, wenn Bildschirm groß genug: */ \
            top: 50%;                       \
            left: 50%;                      \
            margin-top: -262px;             \
            margin-left: -307px;            \
        }                                   \
    }                                       \
");

if (PinHeader == 1) {
    // Bei angehefteter Kopfzeile verschwinden sonst die Dialoge.
    GM_addStyle(".modal { padding-top: 170px; }");
}